Subject: bug#43831: Only when compiled: Wrong number of arguments

From: Jan Nieuwenhuizen <[email-masked]>
Date: Tue, 06 Oct 2020 18:39:35 +0200

Hi!

Running mescc with compiled guile-3.0.4 (guile-3.0-latest on guix
master) code gives

    Wrong number of arguments to #<procedure expr->register (o info)>

Using guile-2.2, or running without compiling is fine.

To reproduce, do

--8<---------------cut here---------------start------------->8---
git clone --branch=wip-guile3 https://git.savannah.gnu.org/git/mes.git
guix environment -l guix.scm
./configure
SCHEME=guile ./pre-inst-env mescc -c scaffold/hello.c
make all-go
SCHEME=guile ./pre-inst-env mescc -c scaffold/hello.c
--8<---------------cut here---------------end--------------->8---

Note that the first run, before `make all-go' runs fine (see hello.s,
hello.o).  The second run, running with compiled .go files, gives

--8<---------------cut here---------------start------------->8---
Backtrace:
In ice-9/boot-9.scm:
  1736:10 16 (with-exception-handler _ _ #:unwind? _ #:unwind-for-type _)
In unknown file:
          15 (apply-smob/0 #<thunk 7ff3356402a0>)
In ice-9/boot-9.scm:
    718:2 14 (call-with-prompt _ _ #<procedure default-prompt-handler (k proc)>)
In ice-9/eval.scm:
    619:8 13 (_ #(#(#<directory (guile-user) 7ff335261f00>)))
In mescc/mescc.scm:
   120:16 12 (mescc:assemble ((numbered-arch? . #f) (kernel . "linux") (arch . "x86_64") (libdir . "/home/?") ?))
In srfi/srfi-1.scm:
   586:17 11 (map1 ("scaffold/hello.c"))
In ice-9/ports.scm:
   445:17 10 (call-with-input-file _ _ #:binary _ #:encoding _ #:guess-encoding _)
    470:4  9 (_ _)
In mescc/compile.scm:
    61:14  8 (c99-ast->info _ _ #:verbose? _)
In srfi/srfi-1.scm:
   460:18  7 (fold #<procedure ast->info (o info)> _ _)
In mescc/compile.scm:
  2652:17  6 (fctn-defn->info _ #<<info> types: (("wchar_t" . #<<type> type: signed size: 4 description: #f>) ?>)
   1901:2  5 (ast->info _ #<<info> types: (("wchar_t" . #<<type> type: signed size: 4 description: #f>) ("uid_?>)
In srfi/srfi-1.scm:
   460:18  4 (fold #<procedure ast->info (o info)> #<<info> types: (("wchar_t" . #<<type> type: signed size: ?> ?)
In mescc/compile.scm:
  1719:24  3 (ast->info _ #<<info> types: (("wchar_t" . #<<type> type: signed size: 4 description: #f>) ("uid_?>)
  1020:30  2 (expr->register _ _)
In srfi/srfi-1.scm:
   501:18  1 (fold-right #<procedure expr->register (o info)> _ _ . _)
In mescc/compile.scm:
    882:0  0 (expr->register _ _)

mescc/compile.scm:882:0: In procedure expr->register:
Wrong number of arguments to #<procedure expr->register (o info)>
--8<---------------cut here---------------end--------------->8---

I'm aware that this isn't exactly a "minimal reprocucing
example"...however I've no idea to get there.

I tried this patch:

--8<---------------cut here---------------start------------->8---
diff --git a/module/mescc/compile.scm b/module/mescc/compile.scm
index 579de2ceb..213909552 100644
--- a/module/mescc/compile.scm
+++ b/module/mescc/compile.scm
@@ -879,7 +879,14 @@
                                                           ((4) 'r-long-mem-add)) n))))))
       (free-register info))))
 
-(define (expr->register o info)
+(define (expr->register o . rest)
+  (when (null? rest)
+    (throw 'expr-register "rest is null for" o))
+  (when (> (length rest) 1)
+    (throw 'expr-register "rest length for:" o (length rest)))
+  (expr->register- o (car rest)))
+
+(define (expr->register- o info)
   (let* ((locals (.locals info))
          (text (.text info))
          (globals (.globals info))
--8<---------------cut here---------------end--------------->8---

to armor expr->register calls and flag an error, which gives a very
similar, and thus even more puzzling backtrace:

--8<---------------cut here---------------start------------->8---
[..]
In mescc/compile.scm:
    887:2  3 (ast->info _ _)
  1027:30  2 (expr->register- _ _)
In srfi/srfi-1.scm:
   501:18  1 (fold-right #<procedure expr->register- (o info)> _ _ . _)
In mescc/compile.scm:
    889:0  0 (expr->register- _ _)
--8<---------------cut here---------------end--------------->8---

because, the new expr->register- has only one call location which is
fine.  Ideas?

Greetings,
Janneke

-- 
Jan Nieuwenhuizen <[email-masked]> | GNU LilyPond http://lilypond.org
Freelance IT http://JoyofSource.com | Avatar® http://AvatarAcademy.com